/*
 * Test error actions.
 */

#include <iostream>
#include <stdio.h>

using namespace std;

#define DIGIT   0x01
#define PLUS    0x02
#define MINUS   0x04
#define DECIMAL 0x08

int expt = 0;

%% ErrAct
	init { expt = 0; }
	action dump_expt {
		if ( expt & DIGIT ) printf(" DIGIT" );
		if ( expt & PLUS ) printf(" PLUS" );
		if ( expt & MINUS ) printf(" MINUS" );
		if ( expt & DECIMAL ) printf(" DECIMAL" );
		printf( "\n" );
	}

	action expt_plus_minus { expt |= PLUS | MINUS; }
	action expt_digit { expt |= DIGIT; }
	action expt_decimal { expt |= DECIMAL; }

	struct {};

	float = (
		( [\-+]? $!expt_plus_minus )
		( [0-9]+ $!expt_digit )
		(
			'.'     $!expt_decimal
			[0-9]+  $!expt_digit
		)? 
	) $!dump_expt;

	main := float '\n';
%%

#define BUFSIZE 1024

int main()
{
	char buf[BUFSIZE];

	while ( fgets( buf, sizeof(buf), stdin ) != 0 ) {
		ErrAct errAct;

		errAct.init();
		errAct.execute( buf, strlen(buf) );
		if ( errAct.finish() > 0 )
			cout << "ACCEPT" << endl;
		else
			cout << "FAIL" << endl;
	}
	return 0;
}
